#include "problem3.hpp"
#include <iostream>

using namespace pe::problem3;

Problem3::Problem3() :
  INIT_LOGGER("problem3")
{
  LOG_DEBUG("Created problem3 engine.");
}

std::set<ull> Problem3::_findFactor(ull number, ull startFactor ) {
  std::set<ull> retval;
  LOG_DEBUG("Recursion for number "<<number << " with start factor " << startFactor);
  for( ull factor = startFactor; factor <= number; factor += 1) {
	if (number % factor == 0) {
	  LOG_DEBUG("Found factor: " << factor);
	  retval.insert(factor);
	  std::set<ull> recursive = _findFactor(number / factor, factor);
	  retval.insert(recursive.begin(), recursive.end());
	  break;
	}
  }
  return retval; 
}

std::set<ull> Problem3::factorize(ull number)
{
  std::set<ull> retval;

  LOG_DEBUG("Factorizing number: "<<number);
  retval = _findFactor(number, 2);
  
  return retval;
}

