#include "problem3/problem3.hpp"
#include "common/common.h"
#include "timer/clock.hpp"
#include <iostream>
#ifdef ENABLE_LOGGING
#include <log4cxx/logger.h>
#include <log4cxx/basicconfigurator.h>
#include <log4cxx/helpers/exception.h>
#include <log4cxx/patternlayout.h>
#include <log4cxx/consoleappender.h>
static const log4cxx::LogString TTCC_CONVERSION_PATTERN(LOG4CXX_STR("%-5p [%c] - %m%n"));
#endif

using namespace pe::problem3;


#ifdef ENABLE_LOGGING
/**
 * Statically initialize the log4cxx library.
 */
void configureLogging(const std::string logString, const log4cxx::LevelPtr level) {
  log4cxx::LayoutPtr layout(new log4cxx::PatternLayout(logString));
  log4cxx::AppenderPtr appender(new log4cxx::ConsoleAppender(layout));
  log4cxx::BasicConfigurator::configure(appender);
  log4cxx::LoggerPtr rootlogger = log4cxx::Logger::getRootLogger();
  rootlogger->setLevel(level);
}
#endif

int main()
{
#ifdef ENABLE_LOGGING
  std::string logPattern(TTCC_CONVERSION_PATTERN);
  log4cxx::LevelPtr logLevel = log4cxx::Level::toLevel("DEBUG");
  configureLogging(logPattern, logLevel);
#endif
  unsigned long long max=600851475143LLU;
  //unsigned long long max=82;
  std::set<unsigned long long> answer;
  std::set<unsigned long long>::iterator it;
  pe::Timer timer;
  Problem3 p3;

  std::cout << "Project Euler Problem 3 version ";
  std::cout <<VERSION_MAJOR<<"."<<VERSION_MINOR;
  std::cout <<"p"<<VERSION_PATCH << std::endl;

  timer.start();
  answer = p3.factorize(max);
  timer.finish();

  std::cout << "Problem 3: "<<std::endl;
  std::cout << "Factors of " << max << " are:" << std::endl;
  for(  it = answer.begin(); it != answer.end(); it++) {
	std::cout << (*it) << " ";
  }
  std::cout << std::endl;
  std::cout << "Runtime was: " << timer.renderToSecond() << std::endl;

  return 0;
}
